(*  Title: 	NEWROOT
    Author: 	Lawrence C Paulson, Cambridge University Computer Laboratory
    Copyright   1990  University of Cambridge

For NEW JERSEY compiler.

Root file for pure Isabelle: all modules in proper order for loading
Loads pure Isabelle into an empty database.

Then load ROOT.ML on subdirectory to add a logic to the database.
*)

val version = "89/10";

(* System.Control.Runtime.softmax := 5000000; *)

(*I/O.  Defines separate identifier for terminal output channel.*)

fun prs s = output (std_out, s); (*  for Version 0.56 *)
(* fun prs s = output std_out s; for Version 0.44 *)

fun writeln s = prs (s ^ "\n");

use "PolyML.ML";
open PolyML;

use "library.ML";
use "term.ML";
use "symtab.ML";
use "queue.ML";
use "pretty.ML";

(* should belong to Pure??? *)
structure Symtab = SymtabFun();
structure Queue = QueueFun();
structure Pretty = PrettyFun(Queue);

(* System.cd "EARLEY";   for Version 0.44 *)
System.Directory.cd "EARLEY";    (* for Versiom 0.56 *)

use "ROOT.ML";

(* System.cd "..";   for Version 0.44 *)
System.Directory.cd "..";   (* for Versiom 0.56 *)

use "sign.ML";
use "sequence.ML";
use "envir.ML";
use "unify.ML";
use "logic.ML";
use "thm.ML";
use "stringtree.ML";
use "tctical.ML";
use "tactic.ML";
use "conv.ML";
use "goals.ML";

use "pure.ML";	(* combines sign up to goals *)

use "simp.ML";  (* simplifier functor: used in object lobics *)

(* Will be shared by all object-logics. *)
structure Pure = PureFun();

(exportML"EXEC";  print "Pure Isabelle\n");
